package jp.ac.takushoku_u.cs;


/**
* ClusterAnalysisNX̓NX^[͂邽߂̃NXłB<BR>
* 2n܂ł̑ΏۂƂA1n܂ł̑lɕ͂s܂B
* @version 1.2.1
* @author ͌ T(Kawahara Shinji)
*/
/**
*ŏIXV 2005N1209
*/
public class ClusterAnalysis{

/**
* ͂sf[^}gNX
*/
    private ArithmeticMatrix dataMatrix;

/**
* UPGMANX^[@\萔łB	
*/    
    public static final int CLUSTERING_UPGMA = 0;
    
/**
* SLINKNX^[@\萔łB
*/
    public static final int CLUSTERING_SLINK = 1;
    
/**
* CLINKNX^[@\萔łB
*/ 
    public static final int CLUSTERING_CLINK = 2;
    
/**
* ގxW\萔łB
*/
    public static final int SIMILARITY_COEFFICIENT = 0;
/**
* ގxW\萔łB
*/
	public static final int DISSIMILARITY_COEFFICIENT = 1;
	
/**
* }gNXTCỸftHgl
*/
    private static final int CLUSTER_MATRIX_VALUE = 5;

    private static double max;
    	    
    private final static double MAX_VALUE = max;
    
/**
* ͂s}gNXƂėvf0̑Ώۂݒ肵܂B
*/
    public ClusterAnalysis(){
	ArithmeticMatrix baseMatrix = new ArithmeticMatrix(CLUSTER_MATRIX_VALUE, CLUSTER_MATRIX_VALUE);
	setMatrix(baseMatrix);
    }	

/**
* Ώۃf[^ɕ͂s}gNXݒ肵܂B<BR>
* @param object IuWFNg
*/
    public ClusterAnalysis(int object){
    	ArithmeticMatrix baseMatrix = new ArithmeticMatrix(object, CLUSTER_MATRIX_VALUE);
    	setMatrix(baseMatrix);
    }

/**
* ɕ͂s}gNXݒ肵܂B<BR>
* @param matrix ͂s}gNX
*/
    public ClusterAnalysis(ArithmeticMatrix matrix){
       
	//f[^}gNXݒ肷
	setMatrix(matrix);
    }

/**
* ͂s}gN̕Ws܂B
* @return W}gNX
*/
    public ArithmeticMatrix getStandardizedMatrix(){
    	double[][] element = new double[dataMatrix.getRowLength()][dataMatrix.getColLength()];
    	for(int i=0; i<dataMatrix.getRowLength(); i++){
    		for(int j=0; j<dataMatrix.getColLength(); j++){
    			element[i][j] = getStandard(i, j);
    		}
    	}
    	ArithmeticMatrix mat = new ArithmeticMatrix(element);
    	return mat;
    }
    
/**
* w肵}gNX̕Ws܂B
* @param matrix w肵}gNX
* @return W}gNX
*/
    public ArithmeticMatrix getStandardizedMatrix(ArithmeticMatrix matrix){
    	double[][] element = new double[matrix.getRowLength()][matrix.getColLength()];
    	for(int i=0; i<matrix.getRowLength(); i++){
    		for(int j=0; j<matrix.getColLength(); j++){
    			element[i][j] = getStandard(matrix,i,j);
    		}
    	}
    	ArithmeticMatrix mat = new ArithmeticMatrix(element);
    	return mat;
    }

/**
* ގxW܂͗ގxWeΏۂƂɔzuގ}gNX߂܂B
* @param RESEMBLANCE_COEFFICIENT ގW
* @return ގ}gNX
*/
    public ArithmeticMatrix getResemblanceMatrix(int RESEMBLANCE_COEFFICIENT){
    	int resem = RESEMBLANCE_COEFFICIENT;
    	ArithmeticMatrix ruiji = new ArithmeticMatrix();
    	if(resem == SIMILARITY_COEFFICIENT){
    		ruiji.matrixCopy(getSimilarityCoefficientMatrix());
    	}
    	if(resem == DISSIMILARITY_COEFFICIENT){
    		ruiji.matrixCopy(getNonResemblanceMatrix());
    	}
    	return ruiji;
    }
    
/**   
* w肵}gNXɁAގxW܂͗ގxWeΏۂƂɔzuގ}gNX߂܂B
* @param matrix w肵}gNX
* @param RESEMBLANCE_COEFFICIENT ގW
* @return ގ}gNX
*/     
    public ArithmeticMatrix getResemblanceMatrix(ArithmeticMatrix matrix, int RESEMBLANCE_COEFFICIENT){
    	int resem = RESEMBLANCE_COEFFICIENT;
    	ArithmeticMatrix ruiji = new ArithmeticMatrix();
    	if(resem == SIMILARITY_COEFFICIENT){
    		ruiji.matrixCopy(getSimilarityCoefficientMatrix(matrix));
    	}
    	if(resem == DISSIMILARITY_COEFFICIENT){
    		ruiji.matrixCopy(getNonResemblanceMatrix(matrix));
    	}
    	return ruiji;
    }
    
/**
* ގxWeΏۂ̑g݂ɂĔzuގ}gNX߂܂B
* @return ގ}gNX
*/
    private ArithmeticMatrix getSimilarityCoefficientMatrix(){
    	ArithmeticMatrix mat = new ArithmeticMatrix(dataMatrix.getColLength(),dataMatrix.getColLength());
    	for(int i=0; i<dataMatrix.getColLength(); i++){
    		for(int j=0; j<dataMatrix.getColLength(); j++){
    			if(i!=j){
    				mat.setCell(i,j,getSimilarityCoefficient(i, j));
    				mat.setCell(j,i,getSimilarityCoefficient(i, j));
    			}
    			else{
    				mat.setCell(i,i,0);
    			}
    		}
    	}
    	return mat;
    }
    
/**
* w肵}gNXɁAގxWeΏۂ̑g݂ɂĔzuގ}gNX߂܂B
* @param matrix w肵}gNX
* @return ގ}gNX
*/
    private ArithmeticMatrix getSimilarityCoefficientMatrix(ArithmeticMatrix matrix){
    	ArithmeticMatrix mat = new ArithmeticMatrix(matrix.getColLength(),matrix.getColLength(),matrix.getColNameArray(),matrix.getColNameArray());
        for(int i=0; i<matrix.getColLength(); i++){
        	for(int j=0; j<matrix.getColLength(); j++){
        		if(i!=j){
        			mat.setCell(i,j,getSimilarityCoefficient(matrix, i ,j));
        			mat.setCell(j,i,getSimilarityCoefficient(matrix, i, j));
        		}
        		else{
        			mat.setCell(i, i ,0);
        		}
        	}
        }
        return mat;
        }

/**
* ގxWeΏۂ̑g݂ɂĔzuގ}gNX߂܂B
* @return ގ}gNX
*/
    private ArithmeticMatrix getNonResemblanceMatrix(){
    	ArithmeticMatrix mat = new ArithmeticMatrix(dataMatrix.getColLength(),dataMatrix.getColLength());
    	for(int i=0; i<dataMatrix.getColLength(); i++){
    		for(int j=0; j<dataMatrix.getColLength(); j++){
    			if(i!=j){
    				mat.setCell(i,j,getDissimilarityCoefficient(i, j));
    				mat.setCell(j,i,getDissimilarityCoefficient(i, j));
    			}
    			else{
    				mat.setCell(i,i,0);
    			}
    		}
    	}
    	return mat;
    }
    
/**
* w肵}gNXɁAގxWeΏۂ̑g݂ɂĔzuގ}gNX߂܂B
* @param matrix w肵}gNX
* @return ގ}gNX
*/
    private ArithmeticMatrix getNonResemblanceMatrix(ArithmeticMatrix matrix){
    	int size = matrix.getColLength();
    	ArithmeticMatrix mat = new ArithmeticMatrix(size,size,matrix.getColNameArray(),matrix.getColNameArray());
    	for(int i=0; i<size; i++){
    		for(int j=0; j<size; j++){
    			if(i!=j){
    				mat.setCell(i,j,getDissimilarityCoefficient(matrix, i ,j));
    				mat.setCell(j,i,getDissimilarityCoefficient(matrix, i, j));
    			}
    			else{
    				mat.setCell(i, i ,0);
    			}
    		}
    	}
    	return mat;
    }

/**
* w肵Ώۂɂ邠鑮̕Ws܂B
* @param attribute w肵ԍ
* @param object w肵Ώ۔ԍ
* @exception NotAttributeException w肵݂Ȃꍇ
* @exception NotObjectException w肵Ώۂ݂Ȃꍇ
* @return WΏۂ̑
*/
    public double getStandard(int attribute, int object){
    	if(attribute <= dataMatrix.getRowLength()){
    		if(object <= dataMatrix.getColLength()){
    			ArithmeticMatrix mat = new ArithmeticMatrix();
    			mat.matrixCopy(dataMatrix);
    			double sum = 0;
    			double ave = 0;
    			double hensa = 0;
    			double sth = 0;
    			double data = 0;
    			double sa = 0;
    			double sa2 = 0;
    			/*ϒl*/
    			for(int i=0; i<dataMatrix.getColLength(); i++){
    				data = 0;
    				data = mat.getCell(attribute, i);
    				sum = data + sum;
    			}
    			ave = sum/dataMatrix.getColLength();
    			/*W΍*/
    			for(int i=0; i<dataMatrix.getColLength(); i++){
    				data = 0;
    				sa = 0;
    				sa2 = 0;
    				data = mat.getCell(attribute, i);
    				sa = data - ave;
    				sa2 = sa * sa;
    				hensa = sa2 + hensa;
    			}
    			sth = Math.sqrt(hensa/(mat.getColLength()-1));
    			
    			return (mat.getCell(attribute, object) - ave)/sth;
    		}
    		else{
    			throw new NotAttributeException("attribute("+ attribute +")");
    		}
    	}
    	else{
    			throw new NotObjectException("object("+ object +")");
    	}
    }
    

/**
* w肵}gNXɁAw肵Ώۂɂ邠鑮̕Ws܂B
* @param matrix w肵}gNX
* @param attribute w肵ԍ
* @param object w肵Ώ۔ԍ
* @exception NotAttributeException w肵݂Ȃꍇ
* @exception NotObjectException w肵Ώۂ݂Ȃꍇ
* @return WΏۂ̑
*/
    public double getStandard(ArithmeticMatrix matrix, int attribute, int object){
    	if(attribute <= dataMatrix.getRowLength()){
    		if(object <= dataMatrix.getColLength()){
    			ArithmeticMatrix mat = new ArithmeticMatrix();
    			mat.matrixCopy(matrix);
    			double sum = 0;
    			double ave = 0;
    			double hensa = 0;
    			double sth = 0;
    			double data = 0;
    			double sa = 0;
    			double sa2 = 0;
    			/*ϒl*/
    			for(int i=0; i<matrix.getColLength(); i++){
    				data = 0;
    				data = mat.getCell(attribute, i);
    				sum = data + sum;
    			}
    			ave = sum/matrix.getColLength();
    			/*W΍*/
    			for(int i=0; i<matrix.getColLength(); i++){
    				data = 0;
    				sa = 0;
    				sa2 = 0;
    				data = mat.getCell(attribute, i);
    				sa = data - ave;
    				sa2 = sa * sa;
    				hensa = sa2 + hensa;
    			}
    			sth = Math.sqrt(hensa/(mat.getColLength()-1));
    			
    			return (mat.getCell(attribute, object) - ave)/sth;
    		}
    		else{
    			throw new NotAttributeException("attribute("+ attribute +")");
    		}
    	}
    	else{
    		throw new NotObjectException("object("+ object +")");
    	}
    }
    
/**
* 2̑Ώۂ̗ގxW߂܂B
* @param object1 w肵1ڂ̑Ώ۔ԍ
* @param object2 w肵2ڂ̑Ώ۔ԍ
* @exception NotObjectException w肵Ώۂ݂Ȃꍇ
* @return ގxW 
*/
    public double getSimilarityCoefficient(int object1, int object2){
    	if(object1 <= dataMatrix.getColLength() && object2 <= dataMatrix.getColLength()){
    		double sum1 = 0;
    		double data1 = 0;
    		double data2 = 0;
    		double[] ave = dataMatrix.getRowAverageArray();
    		double sqr1 = 0;
    		double sqr2 = 0;
    		double nume = 0;
    		double deno = 0;
    	
    		for(int i=0; i<dataMatrix.getRowLength(); i++){
    			sum1 = 0;
    			data1 = 0;
    			data2 = 0;
    			sum1 = (dataMatrix.getCell(i,object1)-ave[i]) * (dataMatrix.getCell(i,object2)-ave[i]);
    			nume = sum1 + nume;
    		
    			data1 = (dataMatrix.getCell(i,object1) - ave[i]) * (dataMatrix.getCell(i,object1) - ave[i]);
    			sqr1 = data1 + sqr1;
    		
    			data2 = (dataMatrix.getCell(i,object2) - ave[i]) * (dataMatrix.getCell(i,object2) - ave[i]);
    			sqr2 = data2 + sqr2;
    		}
    		deno = Math.sqrt(sqr1) * Math.sqrt(sqr2);
    	
    		return nume/deno;
    	}
    	else{
    		throw new NotObjectException("object("+ object1 +","+object2+")");
    	}
    }
/**
* w肳ꂽ}gNXɁAQ̑Ώۂ̗ގxW߂܂B
* @param matrix ͂s}gNX
* @param object1 w肵1ڂ̑Ώ۔ԍ
* @param object2 w肵2ڂ̑Ώ۔ԍ
* @return ގxW 
*/
    public double getSimilarityCoefficient(ArithmeticMatrix matrix, int object1, int object2){
    	if(object1 <= dataMatrix.getColLength() && object2 <= dataMatrix.getColLength()){
    		double sum1 = 0;
    		double data1 = 0;
    		double data2 = 0;
    		double[] ave = matrix.getRowAverageArray();
    		double sqr1 = 0;
    		double sqr2 = 0;
    		double nume = 0;
    		double deno = 0;
   
    	
    		for(int i=0; i<matrix.getRowLength(); i++){
    			sum1 = 0;
    			data1 = 0;
    			data2 = 0;
    			sum1 = (matrix.getCell(i,object1)-ave[i]) * (matrix.getCell(i,object2)-ave[i]);
    			nume = sum1 + nume;
    		
    			data1 = (matrix.getCell(i,object1) - ave[i]) * (matrix.getCell(i,object1) - ave[i]);
    			sqr1 = data1 + sqr1;
    			data2 = (matrix.getCell(i,object2) - ave[i]) * (matrix.getCell(i,object2) - ave[i]);
    			sqr2 = data2 + sqr2;
    		}
    		deno = Math.sqrt(sqr1) * Math.sqrt(sqr2);
    	
    		return nume/deno;
    	}
    	else{
    		throw new NotObjectException("object("+ object1 +","+object2+")");
    	}
    }


/**
* w肵Q̑Ώۂ̔ގxW߂܂B
* @param object1 w肵1ڂ̑Ώ۔ԍ
* @param object2 w肵2ڂ̑Ώ۔ԍ
* @return ގxW
*/
    public double getDissimilarityCoefficient(int object1, int object2){
    	if(object1 <= dataMatrix.getColLength() && object2 <= dataMatrix.getColLength()){
    		ArithmeticMatrix mat = new ArithmeticMatrix();
    		mat.matrixCopy(dataMatrix);
    		double data1 = 0; 
    		double data2 = 0;
    		double sub = 0;
    		double squ = 0;
    		double sum = 0;
    	
    		for(int i=0; i<dataMatrix.getRowLength(); i++){
    			data1 = 0;
    			data2 = 0;
    			sub = 0;
    			squ = 0;
    			data1 = mat.getCell(i,object1);
    			data2 = mat.getCell(i,object2);
    			sub = data1 - data2;
    			squ = sub * sub;
    			sum = sum + squ;
    		}
    		return Math.sqrt(sum);
    	}
    	else{
    		throw new NotObjectException("object("+ object1 +","+object2+")");
    	}
    }
    	
    /**
    * w肵}gNXɁAQ̑ΏۂɂĂ̔ގxW߂܂B
    * @param matrix ͂s}gNX
    * @param object1 w肵1ڂ̑Ώ۔ԍ
    * @param object2 w肵2ڂ̑Ώ۔ԍ
    * @return ގxW
    */
        public double getDissimilarityCoefficient(ArithmeticMatrix matrix, int object1, int object2){
        	if(object1 <= dataMatrix.getColLength() && object2 <= dataMatrix.getColLength()){
        		ArithmeticMatrix mat = new ArithmeticMatrix();
        		mat.matrixCopy(matrix);
        		double data1 = 0;
        		double data2 = 0;
        		double sub = 0;
        		double squ = 0;
        		double sum = 0;
        	
        		for(int i=0; i<mat.getRowLength(); i++){       		
        			data1 = 0;
        			data2 = 0;
        			sub = 0;
        			squ = 0;
        			data1 = mat.getCell(i,object1);
        			data2 = mat.getCell(i,object2);
        			sub = data1 - data2;
        			squ = sub * sub;
        			sum = sum + squ;
        		}
        		return Math.sqrt(sum);
        	}
        	else{
        		throw new NotObjectException("object("+ object1 +","+object2+")");
        	}
        }
    
/**
* w肵f[^}gNXIꂽNX^[@ƗގWɁAR[tF}gNXɕϊ܂B 
* @param matrix f[^}gNX
* @param CLUSTERING_METHOD NX^[@\萔
* @param RESEMBLANCE_COEFFICIENT ގW\萔
* @return R[tF}gNX
*/
   public ArithmeticMatrix getCorfeneticMatrix(ArithmeticMatrix matrix, int CLUSTERING_METHOD,int RESEMBLANCE_COEFFICIENT){
   	    int meth = CLUSTERING_METHOD;
   	    int re =RESEMBLANCE_COEFFICIENT;
   	    ArithmeticMatrix corfen = new ArithmeticMatrix();
   	    switch(meth){
		case CLUSTERING_UPGMA:
			if(re == SIMILARITY_COEFFICIENT){
				corfen.matrixCopy(getUpgmaCorfeneticMatrix(matrix,re));	
			}
			if(re == DISSIMILARITY_COEFFICIENT){
				corfen.matrixCopy(getUpgmaCorfeneticMatrix(matrix,re));
			}
			break;
   	    
		case CLUSTERING_SLINK:
			if(re == SIMILARITY_COEFFICIENT){
				corfen.matrixCopy(getSlinkCorfeneticMatrix(matrix,re));
			}
			if(re == DISSIMILARITY_COEFFICIENT){
				corfen.matrixCopy(getSlinkCorfeneticMatrix(matrix,re));
			}
			break;
			
		case CLUSTERING_CLINK:
			if(re == SIMILARITY_COEFFICIENT){
				corfen.matrixCopy(getClinkCorfeneticMatrix(matrix,re));
			}
			if(re == DISSIMILARITY_COEFFICIENT){
				corfen.matrixCopy(getClinkCorfeneticMatrix(matrix,re));
			}
			break;
   	    }	
		return corfen;
   }
   
   /**
   * f[^}gNXIꂽNX^[@ƗގWɁAR[tF}gNXɕϊ܂B 
   * @param CLUSTERING_METHOD NX^[@\萔
   * @param RESEMBLANCE_COEFFICIENT ގW\萔
   * @return R[tF}gNX
   */
      public ArithmeticMatrix getCorfeneticMatrix(int CLUSTERING_METHOD,int RESEMBLANCE_COEFFICIENT){
      	    int meth = CLUSTERING_METHOD;
      	    int re =RESEMBLANCE_COEFFICIENT;
      	    ArithmeticMatrix corfen = new ArithmeticMatrix();
      	    switch(meth){
   		case CLUSTERING_UPGMA:
   			if(re == SIMILARITY_COEFFICIENT){
   				corfen.matrixCopy(getUpgmaCorfeneticMatrix(dataMatrix,re));	
   			}
   			if(re == DISSIMILARITY_COEFFICIENT){
   				corfen.matrixCopy(getUpgmaCorfeneticMatrix(dataMatrix,re));
   			}
   			break;
      	    
   		case CLUSTERING_SLINK:
   			if(re == SIMILARITY_COEFFICIENT){
   				corfen.matrixCopy(getSlinkCorfeneticMatrix(dataMatrix,re));
   			}
   			if(re == DISSIMILARITY_COEFFICIENT){
   				corfen.matrixCopy(getSlinkCorfeneticMatrix(dataMatrix,re));
   			}
   			break;
   			
   		case CLUSTERING_CLINK:
   			if(re == SIMILARITY_COEFFICIENT){
   				corfen.matrixCopy(getClinkCorfeneticMatrix(dataMatrix,re));
   			}
   			if(re == DISSIMILARITY_COEFFICIENT){
   				corfen.matrixCopy(getClinkCorfeneticMatrix(dataMatrix,re));
   			}
   			break;
      	    }	
   		return corfen;
      }
      
    
/**
* f[^}gNXR[tFW}gNXɕϊ܂B
* @param matrix }gNX
* @param resemcoef ގW\萔
* @return R[tF}gNX
*/
    private ArithmeticMatrix getUpgmaCorfeneticMatrix(ArithmeticMatrix matrix, int resemcoef){
    	int re = resemcoef;
    	if(re == DISSIMILARITY_COEFFICIENT){
    	int size = matrix.getColLength();
    	//ގ}gNXݒ
    	ArithmeticMatrix ruijiMatrix = new ArithmeticMatrix();
    	//ގ}gNX̔z񖼂
    	String[] name = new String[matrix.getColLength()];
    	for(int i=0; i<size; i++){
    		name[i] = String.valueOf(i+",");
    	}
    	ruijiMatrix.matrixCopy(getNonResemblanceMatrix(matrix));
    	ruijiMatrix.nameColCopy(name);
    	ruijiMatrix.nameRowCopy(name);
    	
    		//R[tF}gNXݒ
    	ArithmeticMatrix corfen = new ArithmeticMatrix(size,size);
    	corfen.nameColCopy(matrix.getColNameArray());
    	corfen.nameRowCopy(matrix.getColNameArray());
    
    	//Ĕzp}gNX̐ݒ
    	ArithmeticMatrix umat = new ArithmeticMatrix();
    	umat.matrixCopy(ruijiMatrix);
    	//ŏl	
    	int[] rowcol = minRowCol(umat);
    	int row = rowcol[0];
    	int col = rowcol[1];
    
    	int count = size - 2;  //}gNX̍Ĕz̉
    	
    	//1ڂ̍Ĕz
    	corfen.setCell(row,col,umat.getCell(row,col));
    	corfen.setCell(col,row,umat.getCell(col,row));
    	umat.matrixCopy(getUpgmaObjectUniteMatrix(row,col,ruijiMatrix,umat));
    	//2ڈȍ~̃NX^[
    	String rn;
    	String rname[];
    	String cn;
    	String cname[];
		int rs=0;
		int cs=0;
    	int rc[] = new int[2];
    	if(size>3){
    		for(int i=0; i<count; i++){
    			rc = minRowCol(umat);
    			row = rc[0];
    			rn = umat.getRowName(row);
    			rname = rn.split(",");
    			rs = rname.length;
    			col = rc[1];
    			cn = umat.getColName(col);
    			cname = cn.split(",");
    			cs = cname.length;
    	
    		//	outputDoubleMatrix(umat);
    			for(int j=0; j<rs; j++){
    				for(int k=0; k<cs; k++){
    					corfen.setCell(Integer.parseInt(rname[j]),Integer.parseInt(cname[k]),getMinCell(umat));
    					corfen.setCell(Integer.parseInt(cname[k]),Integer.parseInt(rname[j]),getMinCell(umat));
    				}
    			}
    			umat.matrixCopy(getUpgmaObjectUniteMatrix(row,col,ruijiMatrix,umat));
    	
    		}
    	}
    	
    	return corfen;
    	}
    	if(re == SIMILARITY_COEFFICIENT){
    		int size = matrix.getColLength();
        	//ގ}gNXݒ
        	ArithmeticMatrix ruijiMatrix = new ArithmeticMatrix();
        	//ގ}gNX̔z񖼂
        	String[] name = new String[matrix.getColLength()];
        	for(int i=0; i<size; i++){
        		name[i] = String.valueOf(i+",");
        	}
        	ruijiMatrix.matrixCopy(getSimilarityCoefficientMatrix(matrix));
        	ruijiMatrix.nameColCopy(name);
        	ruijiMatrix.nameRowCopy(name);
        	
        		//R[tF}gNXݒ
        	ArithmeticMatrix corfen = new ArithmeticMatrix(size,size);
        	corfen.nameColCopy(matrix.getColNameArray());
        	corfen.nameRowCopy(matrix.getColNameArray());
        
        	//Ĕzp}gNX̐ݒ
        	ArithmeticMatrix umat = new ArithmeticMatrix();
        	umat.matrixCopy(ruijiMatrix);
        	//ŏl	
        	int[] rowcol = maxRowCol(umat);
        	int row = rowcol[0];
        	int col = rowcol[1];
        
        	int count = size - 2;  //}gNX̍Ĕz̉
        	
        	//1ڂ̍Ĕz
        	corfen.setCell(row,col,umat.getCell(row,col));
        	corfen.setCell(col,row,umat.getCell(col,row));
        	umat.matrixCopy(getUpgmaObjectUniteMatrix(row,col,ruijiMatrix,umat));
        	//2ڈȍ~̃NX^[
        	String rn;
        	String rname[];
        	String cn;
        	String cname[];
    		int rs=0;
    		int cs=0;
        	int rc[] = new int[2];
        	if(size>3){
        		for(int i=0; i<count; i++){
        			rc = maxRowCol(umat);
        			row = rc[0];
        			rn = umat.getRowName(row);
        			rname = rn.split(",");
        			rs = rname.length;
        			col = rc[1];
        			cn = umat.getColName(col);
        			cname = cn.split(",");
        			cs = cname.length;
        	
        		//	outputDoubleMatrix(umat);
        			for(int j=0; j<rs; j++){
        				for(int k=0; k<cs; k++){
        					corfen.setCell(Integer.parseInt(rname[j]),Integer.parseInt(cname[k]),getMaxCell(umat));
        					corfen.setCell(Integer.parseInt(cname[k]),Integer.parseInt(rname[j]),getMaxCell(umat));
        				}
        			}
        			umat.matrixCopy(getUpgmaObjectUniteMatrix(row,col,ruijiMatrix,umat));
        	
        		}
        	}
        	
        	return corfen;
    		
    	}
		return null;
    }


    
    /**
    * f[^}gNXR[tFW}gNXɕϊ܂B
    * @param matrix }gNX
    * @param resecoef ގW\萔
    * @return R[tF}gNX
    */
        private ArithmeticMatrix getSlinkCorfeneticMatrix(ArithmeticMatrix matrix, int resecoef ){
        	int re = resecoef;
        	if(re == DISSIMILARITY_COEFFICIENT){
        	int size = matrix.getColLength();
        	//ގ}gNXݒ
        	ArithmeticMatrix ruijiMatrix = new ArithmeticMatrix();
        	//ގ}gNX̔z񖼂
        	String[] name = new String[matrix.getColLength()];
        	for(int i=0; i<size; i++){
        		name[i] = String.valueOf(i+",");
        	}
        	ruijiMatrix.matrixCopy(getNonResemblanceMatrix(matrix));
        	ruijiMatrix.nameColCopy(name);
        	ruijiMatrix.nameRowCopy(name);
        	
        		//R[tF}gNXݒ
        	ArithmeticMatrix corfen = new ArithmeticMatrix(size,size);
        	corfen.nameColCopy(matrix.getColNameArray());
        	corfen.nameRowCopy(matrix.getColNameArray());
        
        	//Ĕzp}gNX̐ݒ
        	ArithmeticMatrix umat = new ArithmeticMatrix();
        	umat.matrixCopy(ruijiMatrix);
        	//ŏl	
        	int[] rowcol = minRowCol(umat);
        	int row = rowcol[0];
        	int col = rowcol[1];
        
        	int count = size - 2;  //}gNX̍Ĕz̉
        	
        	//1ڂ̍Ĕz
        	corfen.setCell(row,col,umat.getCell(row,col));
        	corfen.setCell(col,row,umat.getCell(col,row));
        	umat.matrixCopy(getSlinkObjectUniteMatrix(row,col,ruijiMatrix,umat));
        	//2ڈȍ~̃NX^[
        	String rn;
        	String rname[];
        	String cn;
        	String cname[];
    		int rs=0;
    		int cs=0;
        	int rc[] = new int[2];
        	if(size>3){
        		for(int i=0; i<count; i++){
        			rc = minRowCol(umat);
        			row = rc[0];
        			rn = umat.getRowName(row);
        			rname = rn.split(",");
        			rs = rname.length;
        			col = rc[1];
        			cn = umat.getColName(col);
        			cname = cn.split(",");
        			cs = cname.length;
        	
        		//	outputDoubleMatrix(umat);
        			for(int j=0; j<rs; j++){
        				for(int k=0; k<cs; k++){
        					corfen.setCell(Integer.parseInt(rname[j]),Integer.parseInt(cname[k]),getMinCell(umat));
        					corfen.setCell(Integer.parseInt(cname[k]),Integer.parseInt(rname[j]),getMinCell(umat));
        				}
        			}
        			umat.matrixCopy(getSlinkObjectUniteMatrix(row,col,ruijiMatrix,umat));
        	
        		}
        	}
        
        	return corfen;
        	}
        	if(re == SIMILARITY_COEFFICIENT){
        		int size = matrix.getColLength();
            	//ގ}gNXݒ
            	ArithmeticMatrix ruijiMatrix = new ArithmeticMatrix();
            	//ގ}gNX̔z񖼂
            	String[] name = new String[matrix.getColLength()];
            	for(int i=0; i<size; i++){
            		name[i] = String.valueOf(i+",");
            	}
            	ruijiMatrix.matrixCopy(getNonResemblanceMatrix(matrix));
            	ruijiMatrix.nameColCopy(name);
            	ruijiMatrix.nameRowCopy(name);
            	
            		//R[tF}gNXݒ
            	ArithmeticMatrix corfen = new ArithmeticMatrix(size,size);
            	corfen.nameColCopy(matrix.getColNameArray());
            	corfen.nameRowCopy(matrix.getColNameArray());
            
            	//Ĕzp}gNX̐ݒ
            	ArithmeticMatrix umat = new ArithmeticMatrix();
            	umat.matrixCopy(ruijiMatrix);
            	//ŏl	
            	int[] rowcol = maxRowCol(umat);
            	int row = rowcol[0];
            	int col = rowcol[1];
            
            	int count = size - 2;  //}gNX̍Ĕz̉
            	
            	//1ڂ̍Ĕz
            	corfen.setCell(row,col,umat.getCell(row,col));
            	corfen.setCell(col,row,umat.getCell(col,row));
            	umat.matrixCopy(getClinkObjectUniteMatrix(row,col,ruijiMatrix,umat));
            	//2ڈȍ~̃NX^[
            	String rn;
            	String rname[];
            	String cn;
            	String cname[];
        		int rs=0;
        		int cs=0;
            	int rc[] = new int[2];
            	if(size>3){
            		for(int i=0; i<count; i++){
            			rc = maxRowCol(umat);
            			row = rc[0];
            			rn = umat.getRowName(row);
            			rname = rn.split(",");
            			rs = rname.length;
            			col = rc[1];
            			cn = umat.getColName(col);
            			cname = cn.split(",");
            			cs = cname.length;
            	
            		//	outputDoubleMatrix(umat);
            			for(int j=0; j<rs; j++){
            				for(int k=0; k<cs; k++){
            					corfen.setCell(Integer.parseInt(rname[j]),Integer.parseInt(cname[k]),getMaxCell(umat));
            					corfen.setCell(Integer.parseInt(cname[k]),Integer.parseInt(rname[j]),getMaxCell(umat));
            				}
            			}
            			umat.matrixCopy(getClinkObjectUniteMatrix(row,col,ruijiMatrix,umat));
            	
            		}
            	}
            
            	return corfen;
        		
        	}
			return null;
        }
        
        /**
         * f[^}gNXR[tFW}gNXɕϊ܂B
         * @param matrix }gNX
         * @param resecoef
         * @return R[tF}gNX
         */
             private ArithmeticMatrix getClinkCorfeneticMatrix(ArithmeticMatrix matrix,int resecoef){
             	int re = resecoef;
             	if(re == DISSIMILARITY_COEFFICIENT){
             		int size = matrix.getColLength();
             		//ގ}gNXݒ
             		ArithmeticMatrix ruijiMatrix = new ArithmeticMatrix();
             		//ގ}gNX̔z񖼂
             		String[] name = new String[matrix.getColLength()];
             		for(int i=0; i<size; i++){
             			name[i] = String.valueOf(i+",");
             		}
             		ruijiMatrix.matrixCopy(getNonResemblanceMatrix(matrix));
             		ruijiMatrix.nameColCopy(name);
             		ruijiMatrix.nameRowCopy(name);
             	
             			//R[tF}gNXݒ
             		ArithmeticMatrix corfen = new ArithmeticMatrix(size,size);
             		corfen.nameColCopy(matrix.getColNameArray());
             		corfen.nameRowCopy(matrix.getColNameArray());
             
             		//Ĕzp}gNX̐ݒ
             		ArithmeticMatrix umat = new ArithmeticMatrix();
             		umat.matrixCopy(ruijiMatrix);
             		//ŏl	
             		int[] rowcol = minRowCol(umat);
             		int row = rowcol[0];
             		int col = rowcol[1];
             
             		int count = size - 2;  //}gNX̍Ĕz̉
             	
             		//1ڂ̍Ĕz
             		corfen.setCell(row,col,umat.getCell(row,col));
             		corfen.setCell(col,row,umat.getCell(col,row));
             		umat.matrixCopy(getClinkObjectUniteMatrix(row,col,ruijiMatrix,umat));
             		//2ڈȍ~̃NX^[
             		String rn;
             		String rname[];
             		String cn;
             		String cname[];
             		int rs=0;
             		int cs=0;
             		int rc[] = new int[2];
             		if(size>3){
             			for(int i=0; i<count; i++){
             				rc = minRowCol(umat);
             				row = rc[0];
             				rn = umat.getRowName(row);
             				rname = rn.split(",");
             				rs = rname.length;
             				col = rc[1];
             				cn = umat.getColName(col);
             				cname = cn.split(",");
             				cs = cname.length;
             	
             		//	outputDoubleMatrix(umat);
             				for(int j=0; j<rs; j++){
             					for(int k=0; k<cs; k++){
             						corfen.setCell(Integer.parseInt(rname[j]),Integer.parseInt(cname[k]),getMinCell(umat));
             						corfen.setCell(Integer.parseInt(cname[k]),Integer.parseInt(rname[j]),getMinCell(umat));
             					}
             				}
             				umat.matrixCopy(getClinkObjectUniteMatrix(row,col,ruijiMatrix,umat));
             			}
             		}
             
             		return corfen;
             	}
             	
             	if(re == SIMILARITY_COEFFICIENT){
             		int size = matrix.getColLength();
             		//ގ}gNXݒ
             		ArithmeticMatrix ruijiMatrix = new ArithmeticMatrix();
             		//ގ}gNX̔z񖼂
             		String[] name = new String[matrix.getColLength()];
             		for(int i=0; i<size; i++){
             			name[i] = String.valueOf(i+",");
             		}
             		ruijiMatrix.matrixCopy(getNonResemblanceMatrix(matrix));
             		ruijiMatrix.nameColCopy(name);
             		ruijiMatrix.nameRowCopy(name);
                     	
             		//R[tF}gNXݒ
             		ArithmeticMatrix corfen = new ArithmeticMatrix(size,size);
             		corfen.nameColCopy(matrix.getColNameArray());
             		corfen.nameRowCopy(matrix.getColNameArray());
             		
             		//Ĕzp}gNX̐ݒ
             		ArithmeticMatrix umat = new ArithmeticMatrix();
             		umat.matrixCopy(ruijiMatrix);
             		//ŏl	
             		int[] rowcol = maxRowCol(umat);
             		int row = rowcol[0];
             		int col = rowcol[1];
             		
             		int count = size - 2;  //}gNX̍Ĕz̉
                     	
             		//1ڂ̍Ĕz
             		corfen.setCell(row,col,umat.getCell(row,col));
             		corfen.setCell(col,row,umat.getCell(col,row));
             		umat.matrixCopy(getSlinkObjectUniteMatrix(row,col,ruijiMatrix,umat));
             		//2ڈȍ~̃NX^[
             		String rn;
             		String rname[];
             		String cn;
             		String cname[];
             		int rs=0;
             		int cs=0;
             		int rc[] = new int[2];
             		if(size>3){
             			for(int i=0; i<count; i++){
             				rc = maxRowCol(umat);
             				row = rc[0];
             				rn = umat.getRowName(row);
             				rname = rn.split(",");
             				rs = rname.length;
             				col = rc[1];
             				cn = umat.getColName(col);
             				cname = cn.split(",");
             				cs = cname.length;
             				
             				//	outputDoubleMatrix(umat);
             				for(int j=0; j<rs; j++){
             					for(int k=0; k<cs; k++){
             						corfen.setCell(Integer.parseInt(rname[j]),Integer.parseInt(cname[k]),getMaxCell(umat));
             						corfen.setCell(Integer.parseInt(cname[k]),Integer.parseInt(rname[j]),getMaxCell(umat));
             					}
             				}
             				umat.matrixCopy(getSlinkObjectUniteMatrix(row,col,ruijiMatrix,umat));
                     	
             			}
             		}
             		return corfen;
             	}
             	return null;
             }

/**
* 2̑Ώۂ̗Zs̗ގ}gNXԂ܂B
* @param object1 Zs1ڂ̑Ώ۔ԍ
* @param object2 Zs2ڂ̑Ώ۔ԍ
* @return Zsގ}gNX 
*/
    private ArithmeticMatrix getUpgmaObjectUniteMatrix(int object1, int object2, ArithmeticMatrix ruijiMatrix,ArithmeticMatrix uniteMatrix){
   	
    	int size = ruijiMatrix.getColLength();
        //Z̃}gNX
    	int usize = uniteMatrix.getColLength();
    	ArithmeticMatrix umat = new ArithmeticMatrix(usize-1,usize-1);
    	
    	//ގ}gNX쐬
    	ArithmeticMatrix ruimat = new ArithmeticMatrix();
    	ruimat.matrixCopy(ruijiMatrix);
    	//O擾
    	String o1 = uniteMatrix.getColName(object1);
    	String o2 = uniteMatrix.getColName(object2);
    	String st = o1+o2;
    	String str[];
    	str = st.split(",");
    	int si = str.length;
    	
    	int[] num = new int[usize-1];
    	int count=0;
    	//ZȂIuWFNgԍ擾
    	for(int i=0; i<usize; i++){
    		if(i!=object1 && i!=object2){
    			num[count]=i;
    			count++;
    		}
    	}
    	//̗Zɂ͊֌ŴȂf[^̔zu
    	for(int j=0; j<usize-2; j++){
    		for(int k=0; k<usize-2; k++){
    			umat.setCell(j,k,uniteMatrix.getCell(num[j],num[k]));
    			umat.setCell(k,j,uniteMatrix.getCell(num[k],num[j]));
    		}
    	} 
        double wadata=0;
        int data1;
        String sdata;
        double data2;
        int count2 = count;
        count2 = 0;
        int sri = 0;
        int sd = 0;
        int s = 0;
        //̗ZɊ֌Ŵf[^̔zu
        for(int k=0; k<count; k++){
        	for(int i=0; i<si; i++){
        		data1 = Integer.parseInt(str[i]);
        		sdata = uniteMatrix.getColName(num[k]);
        		String sr[] = sdata.split(",");
        		sri = sr.length;
        		for(int j=0; j<sri; j++){
        			sd = Integer.parseInt(sr[j]);
        			data2 = ruimat.getCell(data1,sd); 
        			wadata = wadata + data2;
        			s++;
        		}
        	}
        	wadata = wadata/s;
        	s = 0;
        	//ZɊ֌Wobject}gNXɐݒ
     		umat.setCell(usize-2,count2,wadata);
     		umat.setCell(count2,usize-2,wadata);
     		data1 = 0;
     		data2 = 0;
     		wadata = 0;
     		count2++;
        }
        
        //umat̔z񖼐ݒ
        String[] ar = new String[usize-1];
        int z=0;
        for(int i=0; i<usize; i++){
        	if(i!=object1 && i!=object2){
        		ar[z] = uniteMatrix.getColName(i);
        		z++;
        	}
        }
        ar[usize-2] = st;
        umat.nameColCopy(ar);
        umat.nameRowCopy(ar);
        return umat;
    }

    /**
    * 2̑Ώۂ̗Zs̗ގ}gNXԂ܂B
    * @param object1 Zs1ڂ̑Ώ۔ԍ
    * @param object2 Zs2ڂ̑Ώ۔ԍ
    * @return Zsގ}gNX 
    */
        private ArithmeticMatrix getSlinkObjectUniteMatrix(int object1, int object2, ArithmeticMatrix ruijiMatrix,ArithmeticMatrix uniteMatrix){
       	
        	int size = ruijiMatrix.getColLength();
            //Z̃}gNX
        	int usize = uniteMatrix.getColLength();
        	ArithmeticMatrix umat = new ArithmeticMatrix(usize-1,usize-1);
        	
        	//ގ}gNX쐬
        	ArithmeticMatrix ruimat = new ArithmeticMatrix();
        	ruimat.matrixCopy(ruijiMatrix);
        	//O擾
        	String o1 = uniteMatrix.getColName(object1);
        	String o2 = uniteMatrix.getColName(object2);
        	String st = o1+o2;
        	String str[];
        	str = st.split(",");
        	int si = str.length;
        	
        	int[] num = new int[usize-1];
        	int count=0;
        	//ZȂIuWFNgԍ擾
        	for(int i=0; i<usize; i++){
        		if(i!=object1 && i!=object2){
        			num[count]=i;
        			count++;
        		}
        	}
        	//̗Zɂ͊֌ŴȂf[^̔zu
        	for(int j=0; j<usize-2; j++){
        		for(int k=0; k<usize-2; k++){
        			umat.setCell(j,k,uniteMatrix.getCell(num[j],num[k]));
        			umat.setCell(k,j,uniteMatrix.getCell(num[k],num[j]));
        		}
        	} 
            int data1;
            String sdata;
            double data2;
            int count2 = count;
            count2 = 0;
            int sri = 0;
            int sd = 0;
            double min = 1000000000;
            //̗ZɊ֌Ŵf[^̔zu
            for(int k=0; k<count; k++){
            	for(int i=0; i<si; i++){
            		data1 = Integer.parseInt(str[i]);
            		sdata = uniteMatrix.getColName(num[k]);
            		String sr[] = sdata.split(",");
            		sri = sr.length;
            		for(int j=0; j<sri; j++){
            			sd = Integer.parseInt(sr[j]);
            			data2 = ruimat.getCell(data1,sd);
            			if(data1 != sd){
            				if(min>data2){
            					min = data2;
            				
            				}
            			}
            		}
            	}
            	//ZɊ֌Wobject}gNXɐݒ
         		umat.setCell(usize-2,count2,min);
         		umat.setCell(count2,usize-2,min);
         		data1 = 0;
         		data2 = 0;
         		count2++;
         		min = 1000000000;
            }
            
            //umat̔z񖼐ݒ
            String[] ar = new String[usize-1];
            int z=0;
            for(int i=0; i<usize; i++){
            	if(i!=object1 && i!=object2){
            		ar[z] = uniteMatrix.getColName(i);
            		z++;
            	}
            }
            ar[usize-2] = st;
            umat.nameColCopy(ar);
            umat.nameRowCopy(ar);
            return umat;
          }
    
    
        /**
         * 2̑Ώۂ̗Zs̗ގ}gNXԂ܂B
         * @param object1 Zs1ڂ̑Ώ۔ԍ
         * @param object2 Zs2ڂ̑Ώ۔ԍ
         * @return Zsގ}gNX 
         */
             private ArithmeticMatrix getClinkObjectUniteMatrix(int object1, int object2, ArithmeticMatrix ruijiMatrix,ArithmeticMatrix uniteMatrix){
            	
             	int size = ruijiMatrix.getColLength();
                 //Z̃}gNX
             	int usize = uniteMatrix.getColLength();
             	ArithmeticMatrix umat = new ArithmeticMatrix(usize-1,usize-1);
             	
             	//ގ}gNX쐬
             	ArithmeticMatrix ruimat = new ArithmeticMatrix();
             	ruimat.matrixCopy(ruijiMatrix);
             	//O擾
             	String o1 = uniteMatrix.getColName(object1);
             	String o2 = uniteMatrix.getColName(object2);
             	String st = o1+o2;
             	String str[];
             	str = st.split(",");
             	int si = str.length;
             	
             	int[] num = new int[usize-1];
             	int count=0;
             	//ZȂIuWFNgԍ擾
             	for(int i=0; i<usize; i++){
             		if(i!=object1 && i!=object2){
             			num[count]=i;
             			count++;
             		}
             	}
             	//̗Zɂ͊֌ŴȂf[^̔zu
             	for(int j=0; j<usize-2; j++){
             		for(int k=0; k<usize-2; k++){
             			umat.setCell(j,k,uniteMatrix.getCell(num[j],num[k]));
             			umat.setCell(k,j,uniteMatrix.getCell(num[k],num[j]));
             		}
             	} 
                 int data1;
                 String sdata;
                 double data2;
                 int count2 = count;
                 count2 = 0;
                 int sri = 0;
                 int sd = 0;
                 double max = 0;
                 //̗ZɊ֌Ŵf[^̔zu
                 for(int k=0; k<count; k++){
                 	for(int i=0; i<si; i++){
                 		data1 = Integer.parseInt(str[i]);
                 		sdata = uniteMatrix.getColName(num[k]);
                 		String sr[] = sdata.split(",");
                 		sri = sr.length;
                 		for(int j=0; j<sri; j++){
                 			sd = Integer.parseInt(sr[j]);
                 			data2 = ruimat.getCell(data1,sd);
                 			if(data1 != sd){
                 				if(max<data2){
                 					max = data2;
                 				
                 				}
                 			}
                 		}
                 	}
                 	//ZɊ֌Wobject}gNXɐݒ
              		umat.setCell(usize-2,count2,max);
              		umat.setCell(count2,usize-2,max);
              		data1 = 0;
              		data2 = 0;
              		count2++;
              		max = 0;
                 }
                 
                 //umat̔z񖼐ݒ
                 String[] ar = new String[usize-1];
                 int z=0;
                 for(int i=0; i<usize; i++){
                 	if(i!=object1 && i!=object2){
                 		ar[z] = uniteMatrix.getColName(i);
                 		z++;
                 	}
                 }
                 ar[usize-2] = st;
                 umat.nameColCopy(ar);
                 umat.nameRowCopy(ar);
                 return umat;
               }
         
        
        
        
/**
* f[^}gNXݒ肵܂B
* @param baseMatrix ݒf[^}gNX
*/
    private void setMatrix(ArithmeticMatrix baseMatrix){
    	dataMatrix = new ArithmeticMatrix();
    	dataMatrix.matrixCopy(baseMatrix);
    }
    //ől̍sƗԂB
    private int[] maxRowCol(ArithmeticMatrix mat){
    	int row =0;
    	int col =0;
    	int rowcol[] = new int[2];
    	double maxValue;
    	maxValue = mat.getCell(0,1);
    	row =0;
    	col =1;
    	for(int i=0; i<mat.getRowLength(); i++){
    		for(int j=0; j<mat.getColLength();j++){
    			if(i!=j){	
    				if(maxValue < mat.getCell(i,j)){
    					maxValue = mat.getCell(i,j);			
    					row = i;
    					col = j;
    				}
    			}
    		}
    	}
    	rowcol[0]= row;
    	rowcol[1]= col;
    	return rowcol;
    }
 
    //ŏl̍sƗԂB
    private int[] minRowCol(ArithmeticMatrix mat){
    	int row = 0;
    	int col = 0;
    	int rowcol[] = new int[2];
    	double minValue;
    	minValue = mat.getCell(0,1);
    	row = 0;
    	col = 1;
    	for(int i=0; i<mat.getRowLength(); i++){
    		for(int j=0; j<mat.getColLength();j++){
    			if(i!=j){	
    				if(minValue > mat.getCell(i,j)){
    					minValue = mat.getCell(i,j);			
    					row = i;
    					col = j;
    				}
    			}
    		}
    	}
    
    	rowcol[0]= row;
    	rowcol[1]= col;
    	return rowcol;
    }
    
    /**
     * }gNX̗vfɂlŏlԂ܂B
     * @param }gNX
     * @return vfɂŏl
     */	
    	private double getMinCell(ArithmeticMatrix mat){
    		double minValue;
    		minValue = mat.getCell(0,1);
    		
    		for(int i=0; i<mat.getRowLength(); i++){
    			for(int j=0; j<mat.getColLength();j++){
    				if(i!=j){
    					if(minValue > mat.getCell(i,j)){
    						minValue = mat.getCell(i,j);				
    					}
    				}
    			}
    		}
    		return minValue;
    	}
    	
    	 /**
         * }gNX̗vfɂlŏlԂ܂B
         * @param }gNX
         * @return vfɂŏl
         */	
        	private double getMaxCell(ArithmeticMatrix mat){
        		double maxValue;
        		maxValue = mat.getCell(0,1);
        		
        		for(int i=0; i<mat.getRowLength(); i++){
        			for(int j=0; j<mat.getColLength();j++){
        				if(i!=j){
        					if(maxValue < mat.getCell(i,j)){
        						maxValue = mat.getCell(i,j);				
        					}
        				}
        			}
        		}
        		return maxValue;
        	}
    	
}

